
#include <iostream>

#include "Gara.hh"
#include "Animale.hh"
#include "VReporter.hh"

Gara::Gara( int t, VReporter * r ) {
    size = 0;
    duration = t;
    theReporter = r;
}

void Gara::add(Animale* a ) {
    animali[size] = a;
    size++;
}

void Gara::start() {
    for (int i=0;i<size;i++) animali[i]->setPosition( 0);

    for (int i=0;i<duration;i++) {
        for (int j=0;j<size;j++) {
            animali[j]->setPosition( animali[j]->getPosition() + animali[j]->getSpeed(i) * 1);
            theReporter->report(animali[j]);
        }
        std::cout << std::endl;
    }
}

void Gara::classifica() {

     sortAnimali();
    for ( int j=0; j<size;j++ ) {
        theReporter->report(animali[j]);
    }

}

void Gara::sortAnimali() {
    for ( int i=0; i<size;i++ )
    {
        int min = i;
        for ( int j=i+1; j<size; j++ )
        {
            if ( *(animali[min]) > *(animali[j]) ) {
                min = j;
            }
        }
        if ( min != i ) {
            Animale * tmp = animali[i];
            animali[i] = animali[min];
            animali[min] = tmp;
        }

    }

}
