#include "Cavallo.hh"
#include <stdlib.h>
#include <math.h>

Cavallo::Cavallo(char * name, double vm, double ep) : Animale(name) {
    vmax = vm;
    exppar = ep;
}

double Cavallo::getSpeed(double t) {
    double v = vmax * ( 1 - exp(-t/exppar));
    double r = (((double)(rand()) / RAND_MAX) - 0.5 ) * v * 0.1;
    return (v+r);
}
